; CPUs/StrongARM/ARMCore.s
; ARMCore module for the Intel StrongARM
;
; 29/Sep/1999 ned

	AREA	ARMCore, CODE, READONLY

	; Include ARMCore constants
	INCLUDE ArmCoreH.s

	; Include zero page map
	INCLUDE Core/ARM/CommonH.s

	; Exports from this module
	EXPORT	ARMCore_Initialise
	EXPORT	ARMCore_Set

ARMCore_Initialise
	; On entry R9=ptr to zero space
	STMFD	R13!, {R0}
	MRC	p15, 0, R0, c0, c0, 0
	STR	R0, [R9, #HALZP_ARMCORE_CPUTYPE]
	MRC	p15, 0, R0, c1, c0, 0
	STR	R0, [R9, #HALZP_ARMCORE_CTRLREG]
	LDMFD	R13!, {R0}
	MOV	PC, R14

ARMCore_Set
	; R0=bits to set
	; R1=bits to change
	STMFD	R13!,{R2}
	LDR	R2,[R9, #HALZP_ARMCORE_CTRLREG]
	BIC	R2,R2,R1
	ORR	R2,R2,R0
	STR	R2,[R9, #HALZP_ARMCORE_CTRLREG]
	MCR	p15, 0, R2, c1, c0, 0
	LDMFD	R13!,{R2}
	MOV	PC, R14

	END
